'use strict';
import React from 'react';
import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
import ProductDetailItem from '../../components/ScanBarCodeComponent/ProductDetailComponent/ProductDetailItem'
import PopupComponent from '../../components/CommonComponent/PopupComponent/PopupComponent'
import ButtonComponent from '../../components/CommonComponent/ButtonComponent/ButtonComponent'
import Qrcode from '../Qrcode/Qrcode'

require('./index.css');
export default class ScanBarCodeContainer extends React.Component{
    constructor(props) {
        super(props);
        const {state, dispatch} = this.props;
        this.state = {
            "barCodeValue":'',
            "canChangeBtnColor":false,
            "showProductInfo":false,
            "showPopup":false,
            "popupInfo":{},
            "showQr":false,
            "qrUrl":"",
            "taskTy":"BS"
        }

    }
    componentWillMount() {
    }
    componentDidMount(){
    }
    componentDidUpdate() {
    }
    componentWillReceiveProps(nextProps){
        //显示查询到的商品的数据
        let {state,changePages} = nextProps;
        let {scanBarCode,userInfo,storeInfo,refreshImg} = state;
        let productInfo = state.scanBarCode;
        let {inventorylossId,skuBaseInfoVo,packingList,positionList,data_currentProblemObj} = productInfo;
        let productDetailUi = <ProductDetailItem
                                    skuBaseInfoVo = {skuBaseInfoVo}
                                    packingList = {packingList}
                                    positionList = {positionList}
                                    data_currentProblemObj = {data_currentProblemObj}
                                    handleAddImg ={this.handleAddImg.bind(this)}
                                    handleDeleteImg ={this.handleDeleteImg.bind(this)}
                                    handleRefreshImg ={this.handleRefreshImg.bind(this)}
                                    handleSubmitProductInfo = {this.handleSubmitProductInfo.bind(this)}
                                    handleSaveEditProductInfo = {this.handleSaveEditProductInfo.bind(this)}
                                    refreshImg = {refreshImg}
                                    changePages = {changePages}

                                />
        if(scanBarCode.skuBaseInfoVo && scanBarCode.skuBaseInfoVo.skuId && this.state.showProductInfo){
            this.setState({
                popupInfo:{
                    showPopup:true,
                    popupChild:productDetailUi
                }
            })
        }
    }
    componentWillUnmount() {
    }
    // 输入条形码改变 onchange事件监听 条形码的值
    handleSaveInputBarCode(event){
        let barCodeValue = event.target.value;
        this.setState({
            barCodeValue :barCodeValue
        },()=>{})

    }
    // 点击输入条形码 确定按钮
    handleSubmitInputClick(){
        // 1. 检查输入的条形码是否为空
        if(!this.state.barCodeValue){
            this.setState({
                showPopup:true,
                popupInfo:{
                    "popupText":"输入合法的条形码",
                    "showPopup":true,
                    "popupButtons": [<ButtonComponent key={"btn"+this.state.barCodeValue} option={this.handleTryAgainClick.bind(this)} text={"再次尝试"}/>]
                }
            })
            return
        }
        // 2. 请求查询接口
            //准备查询数据
        let {getProductInfo,state} = this.props;
        let {headerInfo} = state;
        let postData = {};
        postData.warehouseId = headerInfo.storeId?Number(headerInfo.storeId):Number("7");
        postData.taskId = headerInfo.taskId?Number(headerInfo.taskId):Number("1");
        postData.sellOrderId = headerInfo.sellOrderId?Number(headerInfo.sellOrderId):Number(21);
        postData.skuBarcode = String(this.state.barCodeValue);
        //设置弹窗显示:
        this.setState({
            showProductInfo:true
        },()=>{
            //发送查询action
            getProductInfo(postData)
        })


    }
    // 点击再次再次尝试
    handleTryAgainClick(){
        this.setState({
            showPopup:false
        })
    }

    handleInputBarCode(){
        this.setState({
            canChangeBtnColor:true
        })
    }
    handleOnclick(){
        this.setState({
            showProductInfo:true
        })
    }
    handleSaveEditProductInfo(data){
        console.log("=================储存===")
        let {saveEditProductInfo} = this.props;
        saveEditProductInfo(data)
    }
    //二维码返回
    handleQrBack(){
        this.setState({
            showQr:false
        })
    }
    //上传图片
    handleAddImg(){
        let {state} = this.props;
        let {storeInfo} = state;
        let tmpUrl = "";
        tmpUrl: `${ENV.uploadImg}/${storeInfo.taskId}/${this.state.taskTy}`
        this.setState({
            "showQr":true,
            "taskTy":tmpUrl
        },()=>{
            console.log(tmpUrl)
        })
        console.log("添加照片")
    }
    handleDeleteImg(id){
        console.log(id)
        let {deleteImg,state} = this.props;
        let {storeInfo} = state;
        console.log(this.state.taskTy)
        deleteImg(storeInfo.taskId,this.state.taskTy,id);
    }
    handleRefreshImg(data){
        let {getRefreshImg,state} = this.props;
        let {storeInfo} = state;
        getRefreshImg(storeInfo.taskId,this.state.taskTy);
        console.log("刷新照片")
    }
    //点击编辑报损的商品的提交按钮
    handleSubmitProductInfo(data){
        let {submitProductInfo} = this.props;
        let postaData ={};
        postaData.taskId = "dfdf";
        postaData.inventoryLossId = data.inventoryLossId;
        postaData.lossPostion = data.lossPostion;
        postaData.packingStatus = data.packingStatus;
        postaData.packingStatusImageIds = data.packingStatusImageIds;
        console.log(postaData)
        submitProductInfo(postaData);
        //让弹窗消失
        this.setState({
            showProductInfo:false,
            popupInfo:{
                "showPopup":false,
            }
        })
    }
    render() {
        let {state} = this.props;
        let {userInfo,storeInfo} = state;
        let productInfo = state.scanBarCode;
        let {inventorylossId,skuBaseInfoVo,packingList,positionList} = productInfo;

        return (
            <div className={"scanBarCodeContainer"}>
                {this.state.showQr?(
                    <Qrcode goBack={this.handleQrBack.bind(this)}  url={this.state.taskTy}></Qrcode>
                ):(
                    <div>
                        <HeaderComponent
                            showHeader={CONFIG.headerStatus[1]}
                            userinfo={userInfo}
                            storeInfo={storeInfo}
                        />
                        {
                            this.state.showPopup?(
                                <PopupComponent popupInfo = {this.state.popupInfo} />
                            ):""
                        }
                        <div className={"container"}>
                            <div className={"inputContaienr"}>
                                <input
                                    onChange={this.handleSaveInputBarCode.bind(this)} onFocus={()=>{this.handleInputBarCode.bind(this)()}} placeholder={"点击输入条形码 "} className={"barcodeValueInput"} type="text"/>
                                <button disabled={!this.state.canChangeBtnColor?true:false} onClick={this.handleSubmitInputClick.bind(this)}  className={this.state.canChangeBtnColor?"submitBtn btnFous":"submitBtn"}>确定</button>
                            </div>
                            {
                                this.state.showProductInfo?(
                                    <PopupComponent popupInfo = {this.state.popupInfo}/>
                                ):""
                            }
                        </div>
                    </div>
                )}

            </div>
        )
    }
}
function select(store) {
    return Object.assign({}, {state: store})
}